//+----------------------------------------------------------------------------+
//|                                                                   OsMA.mq4 |
//|                                Copyright  2004, MetaQuotes Software Corp. |
//|                                                 http://www.metaquotes.net/ |
//+----------------------------------------------------------------------------+

#property  copyright "Copyright  2004, MetaQuotes Software Corp."
#property  link      "http://www.metaquotes.net/"
//---- indicator settings
#property  indicator_separate_window
#property  indicator_buffers 1
#property  indicator_color1  DeepSkyBlue
#property  indicator_width1  2

//
//---- indicator parameters
extern int Fast        = 12;
extern int Slow        = 26;
extern int Signal      = 9;
extern int FASTmetod   = 1; //0-MODE_SMA; 1-MODE_EMA; 2-MODE_SMMA; 3-MODE_LWMA
extern int SLOWmetod   = 3; //0-MODE_SMA; 1-MODE_EMA; 2-MODE_SMMA; 3-MODE_LWMA
extern int MACDmetod   = 3; //0-MODE_SMA; 1-MODE_EMA; 2-MODE_SMMA; 3-MODE_LWMA
extern int SIGNALmetod = 3; //0-MODE_SMA; 1-MODE_EMA; 2-MODE_SMMA; 3-MODE_LWMA
//extern int History     = 200;
//

//---- indicator buffers
double     OsmaBuffer    [];
double     MacdBuffer    [];
double     SignalBuffer  [];
double     TempBuffer    [];

//
int init()
{
  IndicatorDigits (8);
  IndicatorBuffers(4);

  //---- drawing settings
  SetIndexStyle    (0,DRAW_HISTOGRAM);
  SetIndexDrawBegin(0,Signal);
  SetIndexLabel    (0,"OsMA");

  //---- indicator buffers mapping
  SetIndexBuffer   (0,OsmaBuffer);
  SetIndexBuffer   (1,MacdBuffer);
  SetIndexBuffer   (2,SignalBuffer);
  SetIndexBuffer   (3,TempBuffer);

  //---- name for DataWindow and indicator subwindow label
  IndicatorShortName("OsMA ("+Fast+","+Slow+","+Signal+")");

  //---- initialization done
  return(0);
}
//
int start()
{
  int limit;
  int counted_bars=IndicatorCounted();
  //----     
  if (counted_bars>0) counted_bars--;
  limit=Bars-counted_bars;
  for (int i=0; i<limit; i++)
  TempBuffer[i]=(High[i+1]+Low[i+1]+Open[i])/3.0;
  //----  MACD
  for (i=0; i<limit; i++)
  MacdBuffer[i]=Smoothing(TempBuffer,Bars,Fast,0,FASTmetod,i)-Smoothing(TempBuffer,Bars,Slow,0,SLOWmetod,i);
  //----   
  for (i=0; i<limit; i++)
  SignalBuffer[i]=Smoothing(MacdBuffer,Bars,Signal,0,SIGNALmetod,i);
  //----  
  for (i=0; i<limit; i++)
  OsmaBuffer[i]=MacdBuffer[i]-SignalBuffer[i];
  //---- done
  return(0);
}
//
//0-MODE_SMA; 1-MODE_EMA; 2-MODE_SMMA; 3-MODE_LWMA
double Smoothing(double array[],int total,int period,int ma_shift,int ma_method,int shift)
{
  switch (ma_method)
  {
   case 1: return(iMAOnArray(array,total,period,ma_shift,MODE_EMA,shift));  break; 
   case 2: return(iMAOnArray(array,total,period,ma_shift,MODE_SMMA,shift)); break; 
   case 3: return(iMAOnArray(array,total,period,ma_shift,MODE_LWMA,shift)); break; 
   default: return(iMAOnArray(array,total,period,ma_shift,MODE_SMA,shift)); break; 
  }
}
//


